﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace CustomPaging.Class
{
    public static class Common
    {
        private const string ConnString = "Data Source=.\\SQLEXPRESS;Initial Catalog=Paging;User ID=sa;Password=123";
        internal static DataTable DataReaderToDataTable(string sQuery, int iStart, int iEnd)
        {
            DataTable schematable = null;
            DataTable dt = null;
            SqlCommand cmdsql;
            SqlDataReader dr = null;
            SqlConnection conn = null;
            long icount = 0;
            try
            {
                //Open the connection and execute the Data Reader          
                conn = new SqlConnection(ConnString);
                conn.Open();
                cmdsql = new SqlCommand(sQuery, conn);
                dr = cmdsql.ExecuteReader(CommandBehavior.CloseConnection);
                schematable = dr.GetSchemaTable();
                dt = new DataTable();

                //Get the Schema of Tables Columns and its types, and load the same into DataTable.
                for (int i = 0; i <= schematable.Rows.Count - 1; i++)
                {
                    DataRow dRow = schematable.Rows[i];
                    DataColumn column = new DataColumn();
                    column.DataType = System.Type.GetType(dRow["DataType"].ToString());
                    column.AllowDBNull = (dRow["AllowDBNull"].ToString() == "True" ? true : false);
                    column.ColumnName = dRow["ColumnName"].ToString();
                    column.Caption = dRow["ColumnName"].ToString();
                    
                    dt.Columns.Add(column);
                    //More DataTable property can be added as required.
                }
                if (iStart == 0) iStart = 1;
                if (iEnd == 0) iEnd = 1;
                icount = 1;

                //Loop the Reader which is executed till the Start and Variable, 
                //Fetch and add the rows one by one to Data Table Till the End Count is reached.
                // Exit the loop and Return Datable.
                while (dr.Read())
                {
                    if (icount >= iStart && icount <= iEnd)
                    {
                        DataRow dRow = dt.NewRow();
                        for (int i = 0; i <= dr.FieldCount - 1; i++)
                        {
                            dRow[i] = dr.GetValue(i);
                        }
                        dt.Rows.Add(dRow);
                    }
                    else if (icount > iEnd)
                    {
                        break;
                    }
                    icount = icount + 1;
                }
            }
            catch (SystemException ex)
            {
                throw ex;
            }
            finally
            {
                conn.Close();
                conn.Dispose();
                schematable.Dispose();
                dr.Close();
                dr.Dispose();
            }
            return dt;
        }
        internal static DataTable GetDataTable(SqlCommand sCommand)
        {
            SqlConnection conn = new SqlConnection(ConnString);
            SqlDataAdapter da = null;
            DataTable dt = new DataTable();
            try
            {
                conn.Open();
                da = new SqlDataAdapter(sCommand);
                da.Fill(dt);
            }
            catch (SystemException ex)
            {
                throw;
            }
            finally
            {
                conn.Close();
                conn.Dispose();
                da.Dispose();
                dt.Dispose();
            }
            return dt;
        }
        internal static DataTable GetDataTable(string sQuery)
        {
            SqlConnection conn = new SqlConnection(ConnString);
            SqlDataAdapter da = null;
            DataTable dt = new DataTable();
            try
            {
                conn.Open();
                da = new SqlDataAdapter(sQuery, conn) { SelectCommand = { CommandText = sQuery } };
                da.Fill(dt);
            }
            catch (SystemException ex)
            {
                throw;
            }
            finally
            {
                conn.Close();
                conn.Dispose();
                da.Dispose();
                dt.Dispose();
            }
            return dt;
        }
    }

    public class TimeObj
    {
        private DateTime _startTime;
        private DateTime _endTime;
        private TimeSpan _timeSpan;

        public TimeObj()
        {
            //Initializing the time span.
            _timeSpan = new TimeSpan(DateTime.Now.Ticks);
        }
        public TimeSpan TS
        {
            get { return _timeSpan;}            
        }

        public void Start()
        {
            _startTime = DateTime.Now;
        }
        public void Stop()
        {
            _endTime = DateTime.Now;
            _timeSpan = _endTime.Subtract(_startTime);
        }
    }
}
